/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  fire.log.enums.YYLoggerTuJingEnum
 *  fire.pb.PropConf$Cross
 *  fire.pb.activity.award.RewardMgr
 *  fire.pb.battle.pvp.PvPHelper
 *  fire.pb.course.CourseManager
 *  fire.pb.mission.activelist.RoleLiveness
 *  fire.pb.talk.MessageMgr
 *  fire.pb.team.Team
 *  fire.pb.team.TeamManager
 *  fire.pb.util.StringConstant
 *  gnet.link.Onlines
 *  mkdb.Procedure
 *  mkdb.Transaction
 *  mkio.Protocol
 *  xbean.Pod
 *  xbean.PvP3Role
 *  xtable.Properties
 *  xtable.Pvp3roles
 */
package fire.pb.battle.pvp3;

import fire.log.enums.YYLoggerTuJingEnum;
import fire.pb.PropConf;
import fire.pb.activity.award.RewardMgr;
import fire.pb.battle.pvp.PvPHelper;
import fire.pb.battle.pvp3.PvP3Control;
import fire.pb.battle.pvp3.PvP3RaceProxy;
import fire.pb.battle.pvp3.PvP3RankVisitor;
import fire.pb.battle.pvp3.PvP3RoleStateManager;
import fire.pb.battle.pvp3.SPvP3MyInfo;
import fire.pb.battle.pvp3.SPvP3OpenBoxState;
import fire.pb.course.CourseManager;
import fire.pb.mission.activelist.RoleLiveness;
import fire.pb.talk.MessageMgr;
import fire.pb.team.Team;
import fire.pb.team.TeamManager;
import fire.pb.util.StringConstant;
import gnet.link.Onlines;
import java.util.ArrayList;
import java.util.List;
import mkdb.Procedure;
import mkdb.Transaction;
import mkio.Protocol;
import xbean.Pod;
import xbean.PvP3Role;
import xtable.Properties;
import xtable.Pvp3roles;

public class PvP3RoleProxy {
    private final long roleId;
    private PvP3Role xpvprole;
    private final boolean readonly;

    public static PvP3RoleProxy getPvP3RoleProxy(long roleId, boolean readonly) {
        PvP3Role xpvprole = null;
        xpvprole = readonly ? Pvp3roles.select((Long)roleId) : Pvp3roles.get((Long)roleId);
        if (xpvprole == null) {
            if (readonly) {
                xpvprole = Pod.newPvP3RoleData();
            } else {
                xpvprole = Pod.newPvP3Role();
                Pvp3roles.insert((Long)roleId, (PvP3Role)xpvprole);
            }
        }
        return new PvP3RoleProxy(roleId, xpvprole, readonly);
    }

    public PvP3RoleProxy(long roleId, PvP3Role xpvprole, boolean readonly) {
        this.roleId = roleId;
        this.xpvprole = xpvprole;
        this.readonly = readonly;
    }

    public void clearBattleInfo() {
        this.xpvprole.setBattlenum(0);
        this.xpvprole.setWinnum(0);
        this.xpvprole.setContinuewinnum(0);
        this.xpvprole.setFirstwinaward(0);
        this.xpvprole.setFivewinaward(0);
        this.xpvprole.setTenbattleaward(0);
    }

    public long getRoleId() {
        return this.roleId;
    }

    public int getGrade() {
        return this.xpvprole.getGrade();
    }

    public int getScore() {
        return this.xpvprole.getScore();
    }

    public int getScoreLevel() {
        return PvPHelper.getScoreLevel((int)this.getScore());
    }

    public int getBattleNum() {
        return this.xpvprole.getBattlenum();
    }

    public int getContinueWinNum() {
        return this.xpvprole.getContinuewinnum();
    }

    public long getLastBattleTime() {
        return this.xpvprole.getLastbattletime();
    }

    public long getLastEnterTime() {
        return this.xpvprole.getLastentertime();
    }

    public int getGradeInActivity() {
        if (PvP3Control.getInstance().isActivityTime(this.xpvprole.getLastentertime()) && this.xpvprole.getGrade() > 0) {
            return this.xpvprole.getGrade();
        }
        return -1;
    }

    public void onEnter(int grade) {
        long now = System.currentTimeMillis();
        if (!PvP3Control.getInstance().isActivityTime(this.xpvprole.getLastentertime())) {
            this.clearBattleInfo();
            this.xpvprole.setLastbattletime(0L);
            this.xpvprole.setScore(0);
        }
        this.xpvprole.setGrade(grade);
        this.xpvprole.setLastentertime(now);
    }

    public int addScore(int addValue, boolean levelUp) {
        this.onAddScore(addValue);
        return addValue;
    }

    private void onAddScore(int addValue) {
        int lastScore = this.getScore();
        this.xpvprole.setScore(lastScore + addValue);
    }

    public void onBattleEnd(boolean isWin, long enemyId, int addScore, PvP3RaceProxy race) {
        RoleLiveness activeRole;
        if (this.readonly) {
            throw new UnsupportedOperationException("If readonly then cant invoke 3v3 onBattleEnd");
        }
        if (race.getXRace() == null) {
            return;
        }
        long now = System.currentTimeMillis();
        this.xpvprole.setLastbattletime(now);
        this.xpvprole.setLastentertime(now);
        if (isWin) {
            this.xpvprole.setWinnum(this.xpvprole.getWinnum() + 1);
            this.xpvprole.setContinuewinnum(Math.min(99, this.xpvprole.getContinuewinnum() + 1));
            if (this.xpvprole.getWinnum() == 1 && this.xpvprole.getFirstwinaward() == 0) {
                this.xpvprole.setFirstwinaward(1);
            }
            if (this.xpvprole.getWinnum() == 5 && this.xpvprole.getFivewinaward() == 0) {
                this.xpvprole.setFivewinaward(1);
            }
        } else {
            this.xpvprole.setContinuewinnum(0);
        }
        this.xpvprole.setBattlenum(this.xpvprole.getBattlenum() + 1);
        if (this.xpvprole.getBattlenum() == 10 && this.xpvprole.getTenbattleaward() == 0) {
            this.xpvprole.setTenbattleaward(1);
        }
        if ((activeRole = RoleLiveness.getRoleLiveness((long)this.roleId)) != null) {
            if (PropConf.Cross.PVP == 0) {
                activeRole.handleActiveLivenessData(241);
            } else {
                activeRole.handleActiveLivenessData(243);
            }
        }
        CourseManager.achieveCourse((long)this.roleId, (int)10, (int)241, (int)0);
        String roleName = Properties.selectRolename((Long)this.roleId);
        race.updateRankingList(this.roleId, roleName, addScore, this.xpvprole.getScore());
        if (addScore > 0) {
            race.acceptVisit(new PvP3RankVisitor(this.roleId, addScore));
        }
        if (isWin && this.xpvprole.getBattlenum() < 99 && this.roleId == PvP3RoleProxy.getTeamMemberIds(this.roleId).get(0)) {
            race.roleReady(this.roleId);
        }
        this.sendSPvP3MyInfo(isWin && race.isReady(this.roleId));
        if (PvP3Control.getLogger().isInfoEnabled()) {
            PvP3Control.getLogger().info((Object)("PVP3::[PvP3RoleProxy.onBattleEnd] roleId:" + this.roleId + " isWin:" + isWin + " enemyId:" + enemyId + " addScore:" + addScore + " score:" + this.xpvprole.getScore() + " continueWinNum:" + this.xpvprole.getContinuewinnum() + " winNum:" + this.xpvprole.getWinnum() + " battleNum:" + this.xpvprole.getBattlenum()));
        }
    }

    public void sendSPvP3MyInfo(boolean ready) {
        SPvP3MyInfo snd = new SPvP3MyInfo();
        snd.firstwin = (byte)this.xpvprole.getFirstwinaward();
        snd.tenfight = (byte)this.xpvprole.getTenbattleaward();
        snd.eightwin = (byte)this.xpvprole.getFivewinaward();
        snd.battlenum = (byte)this.xpvprole.getBattlenum();
        snd.winnum = (byte)this.xpvprole.getWinnum();
        snd.combowinnum = (byte)this.xpvprole.getContinuewinnum();
        snd.score = this.xpvprole.getScore();
        byte by = snd.ready = ready ? (byte)1 : 0;
        if (Transaction.current() != null) {
            Procedure.psendWhileCommit((long)this.roleId, (Protocol)snd);
        } else {
            Onlines.getInstance().send(Long.valueOf(this.roleId), (Protocol)snd);
        }
    }

    public boolean openBox(int boxType) {
        switch (boxType) {
            case 1: {
                if (this.xpvprole.getFirstwinaward() != 1) {
                    if (this.xpvprole.getFirstwinaward() == 0) {
                        MessageMgr.sendMsgNotify((long)this.roleId, (int)160342, (List)MessageMgr.getStringList((Object[])new Object[]{StringConstant.ID2String((String)"首胜奖励", (int)304)}));
                    } else {
                        MessageMgr.sendMsgNotify((long)this.roleId, (int)172000, (List)MessageMgr.getStringList((Object[])new Object[]{StringConstant.ID2String((String)"首胜奖励", (int)304)}));
                    }
                    return false;
                }
                RewardMgr.getInstance().distributeAllAward(this.roleId, 6170, null, YYLoggerTuJingEnum.tujing_Value_PVP3, 0, 4002, "首胜奖励");
                this.xpvprole.setFirstwinaward(2);
                Procedure.psendWhileCommit((long)this.roleId, (Protocol)new SPvP3OpenBoxState(1, 2));
                if (PvP3Control.getLogger().isInfoEnabled()) {
                    PvP3Control.getLogger().info((Object)("PVP3::[PvP3RoleProxy.openBox] roleId:" + this.roleId + " boxType:" + boxType + " firstWinAwardId:" + 6170));
                }
                return true;
            }
            case 2: {
                if (this.xpvprole.getTenbattleaward() != 1) {
                    if (this.xpvprole.getTenbattleaward() == 0) {
                        MessageMgr.sendMsgNotify((long)this.roleId, (int)160342, (List)MessageMgr.getStringList((Object[])new Object[]{StringConstant.ID2String((String)"十战奖励", (int)307)}));
                    } else {
                        MessageMgr.sendMsgNotify((long)this.roleId, (int)172000, (List)MessageMgr.getStringList((Object[])new Object[]{StringConstant.ID2String((String)"十战奖励", (int)307)}));
                    }
                    return false;
                }
                RewardMgr.getInstance().distributeAllAward(this.roleId, 6171, null, YYLoggerTuJingEnum.tujing_Value_PVP3, 0, 4002, "十战奖励");
                Procedure.psendWhileCommit((long)this.roleId, (Protocol)new SPvP3OpenBoxState(2, 2));
                this.xpvprole.setTenbattleaward(2);
                if (PvP3Control.getLogger().isInfoEnabled()) {
                    PvP3Control.getLogger().info((Object)("PVP3::[PvP3RoleProxy.openBox] roleId:" + this.roleId + " boxType:" + boxType + " tenFightAwardId:" + 6171));
                }
                return true;
            }
            case 3: {
                if (this.xpvprole.getFivewinaward() != 1) {
                    if (this.xpvprole.getFivewinaward() == 0) {
                        MessageMgr.sendMsgNotify((long)this.roleId, (int)160342, (List)MessageMgr.getStringList((Object[])new Object[]{StringConstant.ID2String((String)"五胜奖励", (int)305)}));
                    } else {
                        MessageMgr.sendMsgNotify((long)this.roleId, (int)172000, (List)MessageMgr.getStringList((Object[])new Object[]{StringConstant.ID2String((String)"五胜奖励", (int)305)}));
                    }
                    return false;
                }
                RewardMgr.getInstance().distributeAllAward(this.roleId, 6172, null, YYLoggerTuJingEnum.tujing_Value_PVP3, 0, 4002, "五胜奖励");
                Procedure.psendWhileCommit((long)this.roleId, (Protocol)new SPvP3OpenBoxState(3, 2));
                this.xpvprole.setFivewinaward(2);
                if (PvP3Control.getLogger().isInfoEnabled()) {
                    PvP3Control.getLogger().info((Object)("PVP3::[PvP3RoleProxy.openBox] roleId:" + this.roleId + " boxType:" + boxType + " fiveWinAwardId:" + 6172));
                }
                return true;
            }
        }
        return false;
    }

    public static List<Long> getTeamMemberIds(long roleId) {
        Team team = TeamManager.selectTeamByRoleId((long)roleId);
        if (team != null) {
            return team.getNormalMemberIds();
        }
        ArrayList<Long> ids = new ArrayList<Long>();
        ids.add(roleId);
        return ids;
    }

    public static void notifyTeamProtocol(long roleId, Protocol send) {
        List<Long> ids = PvP3RoleProxy.getTeamMemberIds(roleId);
        Procedure.psendWhileCommit(ids, (Protocol)send);
    }

    public static void setTeamMemberPvPState(long roleId, int state) {
        List<Long> ids = PvP3RoleProxy.getTeamMemberIds(roleId);
        for (long id : ids) {
            PvP3RoleStateManager.getInstance().setRolePvPState(id, state);
        }
    }
}

